/***************************************************/
/* Game Excelleration Kit vX                       */
/* Copyright (C) 2001 by HourGlass Software NonInc */
/***************************************************/
#ifndef __GEKContain__
#define __GEKContain__
/*! 
	\author MoJo
    \file GEKContain.h
    \brief Basic Containment
*/

struct GEKRAY
{
public:
	GEKVECTOR3 m_kOrigin;
	GEKVECTOR3 m_kVector;

public:
	GEKRAY(void);
	GEKRAY(const GEKVECTOR3 &kOrigin, const GEKVECTOR3 &kVector);

	inline float GetLength(void) { return m_kVector.GetLength(); };
	inline GEKVECTOR3 GetEnd(void) { return (m_kOrigin + m_kVector); };
};

struct GEKAABB
{
public:
	GEKVECTOR3 m_kMin;
	GEKVECTOR3 m_kMax;

public:
	bool Collision(const GEKAABB &kAABB) const;
	bool Collision(const GEKSPHERE &kSphere) const;

	void Extend(const GEKVECTOR3 &kPoint);
	inline GEKVECTOR3 GetSize(void) { return (m_kMax - m_kMin); };
	inline GEKVECTOR3 GetCenter(void) { return ((m_kMax + m_kMin) / 2.0f); };
};

struct GEKSPHERE
{
public:
	GEKVECTOR3 m_kOrigin;
	float m_fRadius;

public:
	GEKSPHERE(void);
	GEKSPHERE(const GEKVECTOR3 &kOrigin, float fRadius);

	bool Collision(const GEKAABB &kAABB) const;
	bool Collision(const GEKSPHERE &kSphere) const;
};

#endif